#!c:\python\python.exe

import MySQLdb
import sys

USAGE = "__setup_mysql_GPF.py <mysql host> <username> <password>"
error = lambda msg: sys.stderr.write("ERROR> " + msg + "\n") or sys.exit(1)

if len(sys.argv) != 4:
    error(USAGE)

host     = sys.argv[1]
username = sys.argv[2]
password = sys.argv[3]

try:
    mysql = MySQLdb.connect(host=host, user=username, passwd=password)
except MySQLdb.OperationalError, err:
    error("Failed connecting to MySQL server: %s" % err[1])

cursor = mysql.cursor()

try:
    cursor.execute("CREATE DATABASE gpf")
    cursor.execute("USE gpf")

    cursor.execute("""CREATE TABLE toks (
      gpf_id int NOT NULL default '0',
      generation int NOT NULL default '0',
      pool int NOT NULL default '0',
      session int NOT NULL default '0',
      leg int NOT NULL default '0',
      tok int NOT NULL default '0',
      data_len int NOT NULL default '-1',
      data mediumblob NOT NULL,
      type smallint NOT NULL default '0',
      _numeric smallint NOT NULL default '-1',
      bracket smallint NOT NULL default '-1',
      quote smallint NOT NULL default '-1',
      special smallint NOT NULL default '-1',
      other smallint NOT NULL default '-1',
      covered int NOT NULL default '1',
      PRIMARY KEY (gpf_id,generation,pool,session,leg,tok),
      KEY tok (tok),
      KEY leg (leg),
      KEY session (session),
      KEY pool (pool),
      KEY generation (generation),
      KEY gpf_id (gpf_id)
    ) ENGINE=MyISAM""")

    cursor.execute("""CREATE TABLE legs (
      gpf_id int NOT NULL default '0',
      generation int NOT NULL default '0',
      pool int NOT NULL default '0',
      session int NOT NULL default '0',
      leg int NOT NULL default '0',
      total_toks int NOT NULL default '-1',
      type smallint NOT NULL default '0',
      data_len int NOT NULL default '-1',
      data mediumblob NOT NULL,
      error smallint NOT NULL default '0',
      PRIMARY KEY (gpf_id,generation,pool,session,leg),
      KEY leg (leg),
      KEY session (session),
      KEY pool (pool),
      KEY generation (generation),
      KEY gpf_id (gpf_id)
    ) ENGINE=MyISAM""")

    cursor.execute("""CREATE TABLE sessions (
      gpf_id int NOT NULL default '0',
      generation int NOT NULL default '0',
      pool int NOT NULL default '0',
      session int NOT NULL default '0',
      total_legs int NOT NULL default '-1',
      hit_funcs int NOT NULL default '-1',
      total_funcs int NOT NULL default '-1',
      func_fitness double NOT NULL default '-1',
      hit_blocks int NOT NULL default '-1',
      total_blocks int NOT NULL default '-1',
      block_fitness double NOT NULL default '-1',
      error smallint NOT NULL default '0',
      PRIMARY KEY (gpf_id,generation,pool,session),
      KEY session (session),
      KEY pool (pool),
      KEY generation (generation),
      KEY gpf_id (gpf_id)
    ) ENGINE=MyISAM""")
    
    cursor.execute("""CREATE TABLE pools (
      gpf_id int NOT NULL default '0',
      generation int NOT NULL default '0',
      pool int NOT NULL default '0',
      total_sessions int NOT NULL default '-1',
      hit_funcs int NOT NULL default '-1',
      total_funcs int NOT NULL default '-1',
      func_fitness double NOT NULL default '-1',
      hit_blocks int NOT NULL default '-1',
      total_blocks int NOT NULL default '-1',
      block_fitness double NOT NULL default '-1',
      PRIMARY KEY (gpf_id,generation,pool),
      KEY pool (pool),
      KEY generation (generation),
      KEY gpf_id (gpf_id)
    ) ENGINE=MyISAM""")
    
    cursor.execute("""CREATE TABLE hits (
      gpf_id int NOT NULL default '0',
      generation int NOT NULL default '0',
      pool int NOT NULL default '0',
      session int NOT NULL default '0',
      num int(10) unsigned NOT NULL default '0',
      eip int(10) unsigned NOT NULL default '0',
      tid int(10) unsigned NOT NULL default '0',
      eax int(10) unsigned NOT NULL default '0',
      ebx int(10) unsigned NOT NULL default '0',
      ecx int(10) unsigned NOT NULL default '0',
      edx int(10) unsigned NOT NULL default '0',
      edi int(10) unsigned NOT NULL default '0',
      esi int(10) unsigned NOT NULL default '0',
      ebp int(10) unsigned NOT NULL default '0',
      esp int(10) unsigned NOT NULL default '0',
      esp_4 int(10) unsigned NOT NULL default '0',
      esp_8 int(10) unsigned NOT NULL default '0',
      esp_c int(10) unsigned NOT NULL default '0',
      esp_10 int(10) unsigned NOT NULL default '0',
      eax_deref text,
      ebx_deref text,
      ecx_deref text,
      edx_deref text,
      edi_deref text,
      esi_deref text,
      ebp_deref text,
      esp_deref text,
      esp_4_deref text,
      esp_8_deref text,
      esp_c_deref text,
      esp_10_deref text,
      is_function int(1) unsigned NOT NULL default '0',
      module varchar(255) NOT NULL default '',
      base int(10) unsigned NOT NULL default '0',
      PRIMARY KEY  (gpf_id, generation, pool, session, num),
      KEY gpf_id (gpf_id),
      KEY generation (generation),
      KEY pool (pool),
      KEY session (session),
      KEY num (num)
    ) ENGINE=MyISAM""")
    
    cursor.execute("""CREATE TABLE crash (
      gpf_id int NOT NULL default '0',
      generation int NOT NULL default '0',
      pool int NOT NULL default '0',
      session int NOT NULL default '0',
      crash_number int NOT NULL default '0',
      exception_address int(10) unsigned NOT NULL default '0',
      write_violation int(10) unsigned NOT NULL default '0',
      thread_id int(10) unsigned NOT NULL default '0',
      violation_adress int(10) unsigned NOT NULL default '0',
      PRIMARY KEY  (gpf_id, generation, pool, session, crash_number),
      KEY gpf_id (gpf_id),
      KEY generation (generation),
      KEY pool (pool),
      KEY session (session),
      KEY crash_number (crash_number)
    ) ENGINE=MyISAM""")
    
except MySQLdb.ProgrammingError, err:
    error("Failed creating db / tables: %s" % err[1])

cursor.close()
